'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _foldToObject(memo, _ref) {
  var _ref2 = _slicedToArray(_ref, 2),
      k = _ref2[0],
      v = _ref2[1];

  memo[k] = v;
  return memo;
}

function _objectMap(obj, fn) {
  return _entries(obj).map(fn).reduce(_foldToObject, {});
}

function _entries(obj) {
  return _allOwnProps(obj).map(function (p) {
    return [p, obj[p]];
  });
}

function _allOwnProps(obj) {
  return [].concat(_toConsumableArray(Object.getOwnPropertyNames(obj)), _toConsumableArray(Object.getOwnPropertySymbols(obj)));
}

function _containsDuplicates(xs) {
  return new Set(xs).size !== Array.from(xs).length;
}

var Protocol = function () {
  function Protocol() {
    var _this = this;

    var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        protocolName = _ref3.name,
        _ref3$extends = _ref3.extends,
        _extends = _ref3$extends === undefined ? [] : _ref3$extends,
        _ref3$requires = _ref3.requires,
        requires = _ref3$requires === undefined ? {} : _ref3$requires,
        _ref3$staticRequires = _ref3.staticRequires,
        staticRequires = _ref3$staticRequires === undefined ? {} : _ref3$staticRequires,
        _ref3$provides = _ref3.provides,
        provides = _ref3$provides === undefined ? {} : _ref3$provides,
        _ref3$staticProvides = _ref3.staticProvides,
        staticProvides = _ref3$staticProvides === undefined ? {} : _ref3$staticProvides;

    _classCallCheck(this, Protocol);

    if (_containsDuplicates([].concat(_toConsumableArray(_allOwnProps(requires)), _toConsumableArray(_allOwnProps(staticRequires)), _toConsumableArray(_allOwnProps(provides)), _toConsumableArray(_allOwnProps(staticProvides))))) {
      throw new Error('conflicting protocol entry names');
    }
    if (Object.getOwnPropertyNames(provides).includes('constructor')) {
      throw new Error('illegal prototype property named "constructor"');
    }
    if (Object.getOwnPropertyNames(staticProvides).includes('prototype')) {
      throw new Error('illegal static property named "prototype"');
    }
    this._name = protocolName;
    this._extends = _extends;
    this._requires = _objectMap(requires, function (_ref4) {
      var _ref5 = _slicedToArray(_ref4, 2),
          name = _ref5[0],
          sym = _ref5[1];

      return [name, sym == null ? _this._createSymbol(name, { value: sym }) : sym];
    });
    this._staticRequires = _objectMap(staticRequires, function (_ref6) {
      var _ref7 = _slicedToArray(_ref6, 2),
          name = _ref7[0],
          sym = _ref7[1];

      return [name, sym == null ? _this._createSymbol(name, { value: sym }) : sym];
    });
    this._provides = provides;
    this._staticProvides = staticProvides;
    Object.assign(this, this._requires, this._staticRequires, _objectMap(provides, function (_ref8) {
      var _ref9 = _slicedToArray(_ref8, 2),
          name = _ref9[0],
          desc = _ref9[1];

      return [name, _this._createSymbol(name, desc)];
    }), _objectMap(staticProvides, function (_ref10) {
      var _ref11 = _slicedToArray(_ref10, 2),
          name = _ref11[0],
          desc = _ref11[1];

      return [name, _this._createSymbol(name, desc)];
    }));
  }

  _createClass(Protocol, [{
    key: '_createSymbol',
    value: function _createSymbol(propName, propDescriptor) {
      if ((typeof propName === 'undefined' ? 'undefined' : _typeof(propName)) === 'symbol') return propName;
      var interfaceName = this._name == null ? '' : this._name + '.';
      var description = '' + interfaceName + propName;
      if (propDescriptor.get != null && propDescriptor.set == null) {
        description = 'get ' + description;
      } else if (propDescriptor.get == null && propDescriptor.set != null) {
        description = 'set ' + description;
      }
      return Symbol(description);
    }
  }, {
    key: '_isImplementedBy',
    value: function _isImplementedBy(klass) {
      var _this2 = this;

      return [].concat(_toConsumableArray(Object.values(this._requires)), _toConsumableArray(Object.keys(this._provides).map(function (name) {
        return _this2[name];
      }))).every(function (sym) {
        return sym in klass.prototype;
      }) && [].concat(_toConsumableArray(Object.values(this._staticRequires)), _toConsumableArray(Object.keys(this._staticProvides).map(function (name) {
        return _this2[name];
      }))).every(function (sym) {
        return sym in klass;
      });
    }
  }, {
    key: '_unimplemented',
    value: function _unimplemented(klass) {
      var protoSymbolsWhichWillBeInherited = this._collect(function (i) {
        return Object.getOwnPropertySymbols(i._provides);
      });
      var staticRequiresWhichWillBeInherited = this._collect(function (i) {
        return Object.getOwnPropertySymbols(i._staticProvides);
      });
      return this._collect(function (i) {
        return i._unimplementedHelper(klass, protoSymbolsWhichWillBeInherited, staticRequiresWhichWillBeInherited);
      });
    }
  }, {
    key: '_unimplementedHelper',
    value: function _unimplementedHelper(klass, protoSymbolsWhichWillBeInherited, staticRequiresWhichWillBeInherited) {
      var protoSymbolsWhichMustBeImplemented = Object.values(this._requires);
      var staticRequiresWhichMustBeImplemented = Object.values(this._staticRequires);
      var unimplemented = [];
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = protoSymbolsWhichMustBeImplemented[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var symbol = _step.value;

          if (!(symbol in klass.prototype) && !protoSymbolsWhichWillBeInherited.includes(symbol)) {
            unimplemented.push(symbol);
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = staticRequiresWhichMustBeImplemented[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var _symbol = _step2.value;

          if (!(_symbol in klass) && !staticRequiresWhichWillBeInherited.includes(_symbol)) {
            unimplemented.push(_symbol);
          }
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      return unimplemented;
    }
  }, {
    key: '_collect',
    value: function _collect(fn) {
      return [].concat(_toConsumableArray(fn(this)), _toConsumableArray([].concat.apply([], this._extends.map(function (i) {
        return i._collect(fn);
      }))));
    }
  }, {
    key: '_mixin',
    value: function _mixin(klass) {
      var unimplementedSymbols = this._unimplemented(klass);
      if (unimplementedSymbols.length > 0) {
        throw new Error(unimplementedSymbols.map(function (s) {
          return s.toString();
        }).join(', ') + ' not implemented by ' + klass);
      }

      Object.defineProperties(klass.prototype, this._collect(function (i) {
        return _entries(i._provides).filter(function (_ref12) {
          var _ref13 = _slicedToArray(_ref12, 1),
              name = _ref13[0];

          return !(name in klass.prototype);
        }).map(function (_ref14) {
          var _ref15 = _slicedToArray(_ref14, 2),
              name = _ref15[0],
              desc = _ref15[1];

          return [i[name], desc];
        });
      }).reduceRight(_foldToObject, {}));

      Object.defineProperties(klass, this._collect(function (i) {
        return _entries(i._staticProvides).filter(function (_ref16) {
          var _ref17 = _slicedToArray(_ref16, 1),
              name = _ref17[0];

          return !(name in klass);
        }).map(function (_ref18) {
          var _ref19 = _slicedToArray(_ref18, 2),
              name = _ref19[0],
              desc = _ref19[1];

          return [i[name], desc];
        });
      }).reduceRight(_foldToObject, {}));

      return klass;
    }
  }], [{
    key: 'implement',
    value: function implement(C) {
      if (typeof C !== 'function' || !C.prototype) {
        throw new TypeError('first parameter must have a [[Construct]] internal slot');
      }

      for (var _len = arguments.length, is = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        is[_key - 1] = arguments[_key];
      }

      is.forEach(function (i) {
        return i._mixin(C);
      });
      return C;
    }
  }]);

  return Protocol;
}();

exports.default = Protocol;


Object.setPrototypeOf(Protocol.prototype, null);